Index: /trunk/src/VBox/Installer/win/Scripts/Combined-3-RepackAdditions.cmd
===================================================================
--- /trunk/src/VBox/Installer/win/Scripts/Combined-3-RepackAdditions.cmd	(revision 82467)
+++ /trunk/src/VBox/Installer/win/Scripts/Combined-3-RepackAdditions.cmd	(revision 82468)
@@ -37,5 +37,5 @@
 set _MY_OPT_BUILD_TYPE=@KBUILD_TYPE@
 set _MY_OPT_OUTDIR=%_MY_OPT_UNTAR_DIR%\output
-set _MY_OPT_SRC_DIR=%_MY_OPT_UNTAR_DIR%\..\src
+set _MY_OPT_SRC_DIR=%_MY_SCRIPT_DIR%\resources\
 
 :argument_loop
@@ -191,5 +191,5 @@
 echo **************************************************************************
 cd /d "%_MY_REPACK_DIR_AMD64%" || goto end_failed
-call "%_MY_REPACK_DIR_AMD64%\UnpackBlessedDrivers.cmd" -b "%_MY_BINDIR_AMD64%" -i "%_MY_OPT_SIGNED_AMD64%" -n || goto end_failed
+call "%_MY_REPACK_DIR_AMD64%\UnpackBlessedDrivers.cmd" -b "%_MY_BINDIR_AMD64%" -i "%_MY_OPT_SIGNED_AMD64%" -n -v || goto end_failed
 echo .
 
@@ -198,5 +198,5 @@
 echo **************************************************************************
 cd /d "%_MY_REPACK_DIR_X86%" || goto end_failed
-call "%_MY_REPACK_DIR_X86%\UnpackBlessedDrivers.cmd" -b "%_MY_BINDIR_X86%" -i "%_MY_OPT_SIGNED_X86%" -n || goto end_failed
+call "%_MY_REPACK_DIR_X86%\UnpackBlessedDrivers.cmd" -b "%_MY_BINDIR_X86%" -i "%_MY_OPT_SIGNED_X86%" -n -v || goto end_failed
 echo .
 
@@ -208,4 +208,7 @@
 echo * Building amd64 installer
 echo **************************************************************************
+
+del %_MY_OPT_UNTAR_DIR%\win.amd64\release\bin\additions\VBoxWindowsAdditions-amd64.exe
+cp %_MY_REPACK_DIR_AMD64%\..\obj\uninst.exe %_MY_REPACK_DIR_AMD64%
 
 rem TBD: that has to be converted to invoke auto-generated .cmd
@@ -213,6 +216,6 @@
 %KBUILD_BIN_PATH%\kmk_redirect.exe -C %_MY_OPT_SRC_DIR%/VBox/Additions/WINNT/Installer ^
         -E "PATH_OUT=%_MY_REPACK_DIR_AMD64%\.." ^
-        -E "PATH_TARGET=%_MY_REPACK_DIR_AMD64%\..\obj" ^
-        -E "PATH_TARGET_X86=%_MY_REPACK_DIR_AMD64%\..\obj" ^
+        -E "PATH_TARGET=%_MY_REPACK_DIR_AMD64%" ^
+        -E "PATH_TARGET_X86=%_MY_REPACK_DIR_X86%\resources" ^
         -E "VBOX_PATH_ADDITIONS_WIN_X86=%_MY_REPACK_DIR_AMD64%\..\bin\additions" ^
         -E "VBOX_PATH_DIFX=%KBUILD_DEVTOOLS%\win.x86\DIFx\v2.1-r3" ^
@@ -220,13 +223,13 @@
         -E "VBOX_C_YEAR=@VBOX_C_YEAR@" -E "VBOX_VERSION_STRING=@VBOX_VERSION_STRING@" -E "VBOX_VERSION_STRING_RAW=@VBOX_VERSION_STRING_RAW@" ^
         -E "VBOX_VERSION_MAJOR=@VBOX_VERSION_MAJOR@" -E "VBOX_VERSION_MINOR=@VBOX_VERSION_MINOR@" -E "VBOX_VERSION_BUILD=0" -E "VBOX_SVN_REV=@VBOX_SVN_REV@" ^
-        -E "VBOX_WINDOWS_ADDITIONS_ICON_FILE=%_MY_OPT_SRC_DIR%\VBox\Artwork\win\NonOSE\VirtualBoxGA-vista.ico" ^
-        -E "VBOX_NSIS_ICON_FILE=%_MY_OPT_SRC_DIR%\VBox\Artwork\win\NonOSE\VirtualBoxGA-nsis.ico" ^
+        -E "VBOX_WINDOWS_ADDITIONS_ICON_FILE=%_MY_OPT_SRC_DIR%\VirtualBoxGA-vista.ico" ^
+        -E "VBOX_NSIS_ICON_FILE=%_MY_OPT_SRC_DIR%\VirtualBoxGA-nsis.ico" ^
         -E "VBOX_WITH_GUEST_INSTALL_HELPER=1" -E "VBOX_WITH_GUEST_INSTALLER_UNICODE=1" -E "VBOX_WITH_LICENSE_INSTALL_RTF=1" ^
-        -E "VBOX_WITH_WDDM=1" -E "VBOX_WITH_MESA3D=1" -E "VBOX_BRAND_WIN_ADD_INST_DLGBMP=%_MY_OPT_SRC_DIR%\VBox\Additions\WINNT\Installer\welcome.bmp" ^
-        -E "VBOX_BRAND_LICENSE_RTF=%_MY_OPT_SRC_DIR%\..\doc\License-gpl-2.0.rtf"  -E "BUILD_TYPE=release" -E "BUILD_TARGET_ARCH=amd64" ^
+        -E "VBOX_WITH_WDDM=1" -E "VBOX_WITH_MESA3D=1" -E "VBOX_BRAND_WIN_ADD_INST_DLGBMP=%_MY_OPT_SRC_DIR%\welcome.bmp" ^
+        -E "VBOX_BRAND_LICENSE_RTF=%_MY_OPT_SRC_DIR%\License-gpl-2.0.rtf"  -E "BUILD_TYPE=release" -E "BUILD_TARGET_ARCH=amd64" ^
         --  %KBUILD_DEVTOOLS%/win.x86/nsis/v3.04-log/makensis.exe /NOCD /V2 ^
                 "/DVBOX_SIGN_ADDITIONS=1" ^
                 "/DEXTERNAL_UNINSTALLER=1" ^
-                "%_MY_OPT_SRC_DIR%\VBox\Additions\WINNT\Installer\VBoxGuestAdditions.nsi"
+                "%_MY_OPT_SRC_DIR%\VBoxGuestAdditions.nsi"
 
 rem
@@ -236,4 +239,7 @@
 echo * Building x86 installer
 echo **************************************************************************
+
+del %_MY_OPT_UNTAR_DIR%\win.x86\release\bin\additions\VBoxWindowsAdditions-x86.exe
+cp %_MY_REPACK_DIR_X86%\..\obj\uninst.exe %_MY_REPACK_DIR_X86%\
 
 rem TBD: that has to be converted to invoke auto-generated .cmd
@@ -241,6 +247,6 @@
 %KBUILD_BIN_PATH%\kmk_redirect.exe -C %_MY_OPT_SRC_DIR%/VBox/Additions/WINNT/Installer ^
         -E "PATH_OUT=%_MY_REPACK_DIR_X86%\.." ^
-        -E "PATH_TARGET=%_MY_REPACK_DIR_X86%\..\obj" ^
-        -E "PATH_TARGET_X86=%_MY_REPACK_DIR_X86%\..\obj" ^
+        -E "PATH_TARGET=%_MY_REPACK_DIR_X86%" ^
+        -E "PATH_TARGET_X86=%_MY_REPACK_DIR_X86%\resources" ^
         -E "VBOX_PATH_ADDITIONS_WIN_X86=%_MY_REPACK_DIR_X86%\..\bin\additions" ^
         -E "VBOX_PATH_DIFX=%KBUILD_DEVTOOLS%\win.x86\DIFx\v2.1-r3" ^
@@ -248,13 +254,13 @@
         -E "VBOX_C_YEAR=@VBOX_C_YEAR@" -E "VBOX_VERSION_STRING=@VBOX_VERSION_STRING@" -E "VBOX_VERSION_STRING_RAW=@VBOX_VERSION_STRING_RAW@" ^
         -E "VBOX_VERSION_MAJOR=@VBOX_VERSION_MAJOR@" -E "VBOX_VERSION_MINOR=@VBOX_VERSION_MINOR@" -E "VBOX_VERSION_BUILD=0" -E "VBOX_SVN_REV=@VBOX_SVN_REV@" ^
-        -E "VBOX_WINDOWS_ADDITIONS_ICON_FILE=%_MY_OPT_SRC_DIR%\VBox\Artwork\win\NonOSE\VirtualBoxGA-vista.ico" ^
-        -E "VBOX_NSIS_ICON_FILE=%_MY_OPT_SRC_DIR%\VBox\Artwork\win\NonOSE\VirtualBoxGA-nsis.ico" ^
+        -E "VBOX_WINDOWS_ADDITIONS_ICON_FILE=%_MY_OPT_SRC_DIR%\VirtualBoxGA-vista.ico" ^
+        -E "VBOX_NSIS_ICON_FILE=%_MY_OPT_SRC_DIR%\VirtualBoxGA-nsis.ico" ^
         -E "VBOX_WITH_GUEST_INSTALL_HELPER=1" -E "VBOX_WITH_GUEST_INSTALLER_UNICODE=1" -E "VBOX_WITH_LICENSE_INSTALL_RTF=1" ^
-        -E "VBOX_WITH_WDDM=1" -E "VBOX_WITH_MESA3D=1" -E "VBOX_BRAND_WIN_ADD_INST_DLGBMP=%_MY_OPT_SRC_DIR%\VBox\Additions\WINNT\Installer\welcome.bmp" ^
-        -E "VBOX_BRAND_LICENSE_RTF=%_MY_OPT_SRC_DIR%\..\doc\License-gpl-2.0.rtf"  -E "BUILD_TYPE=release" -E "BUILD_TARGET_ARCH=x86" ^
+        -E "VBOX_WITH_WDDM=1" -E "VBOX_WITH_MESA3D=1" -E "VBOX_BRAND_WIN_ADD_INST_DLGBMP=%_MY_OPT_SRC_DIR%\welcome.bmp" ^
+        -E "VBOX_BRAND_LICENSE_RTF=%_MY_OPT_SRC_DIR%\License-gpl-2.0.rtf"  -E "BUILD_TYPE=release" -E "BUILD_TARGET_ARCH=x86" ^
         --  %KBUILD_DEVTOOLS%/win.x86/nsis/v3.04-log/makensis.exe /NOCD /V2 ^
                 "/DVBOX_SIGN_ADDITIONS=1" ^
                 "/DEXTERNAL_UNINSTALLER=1" ^
-                "%_MY_OPT_SRC_DIR%\VBox\Additions\WINNT\Installer\VBoxGuestAdditions.nsi"
+                "%_MY_OPT_SRC_DIR%\VBoxGuestAdditions.nsi"
 
 rem
@@ -280,7 +286,7 @@
         /VBoxWindowsAdditions-x86.exe=%_MY_OPT_UNTAR_DIR%/win.x86/release/bin/additions/VBoxWindowsAdditions-x86.exe ^
         /VBoxWindowsAdditions.exe=%_MY_OPT_UNTAR_DIR%/win.x86/release/bin/additions/VBoxWindowsAdditions.exe ^
-        /AUTORUN.INF=%_MY_OPT_SRC_DIR%/VBox/Additions/WINNT/Installer/ISO/AUTORUN.INF ^
+        /AUTORUN.INF=%_MY_OPT_SRC_DIR%/AUTORUN.INF ^
         /cert/VBoxCertUtil.exe=%_MY_SCRIPT_DIR%../bin/additions/VBoxCertUtil.exe ^
-        /NT3x/Readme.txt=%_MY_OPT_SRC_DIR%/VBox/Additions/WINNT/Installer/ISO/NT3xReadme.txt ^
+        /NT3x/Readme.txt=%_MY_OPT_SRC_DIR%/NT3xReadme.txt ^
         /NT3x/VBoxGuest.sys=%_MY_OPT_UNTAR_DIR%/win.x86/release/bin/additions/VBoxGuest.sys ^
         /NT3x/VBoxGuest.cat=%_MY_OPT_UNTAR_DIR%/win.x86/release/bin/additions/VBoxGuest.cat ^
Index: /trunk/src/VBox/Installer/win/Scripts/UnpackBlessedDrivers.cmd
===================================================================
--- /trunk/src/VBox/Installer/win/Scripts/UnpackBlessedDrivers.cmd	(revision 82467)
+++ /trunk/src/VBox/Installer/win/Scripts/UnpackBlessedDrivers.cmd	(revision 82468)
@@ -36,4 +36,5 @@
 set _MY_OPT_INPUT=
 set _MY_OPT_SIGN_CAT=1
+set _MY_OPT_SIGN_VERIFY=1
 
 :argument_loop
@@ -54,4 +55,7 @@
 if ".%1" == ".-n"           goto opt_n
 if ".%1" == ".--no-sign-cat" goto opt_n
+if ".%1" == ".-v"           goto opt_v
+if ".%1" == ".--no-sign-verify" goto opt_v
+
 echo syntax error: Unknown option: %1
 echo               Try --help to list valid options.
@@ -73,5 +77,5 @@
 echo will be signed again and the Microsoft signature merged with ours.
 echo .
-echo Usage: UnpackBlessedDrivers.cmd [-b bindir] [-n/--no-sign-cat] -i input.zip
+echo Usage: UnpackBlessedDrivers.cmd [-b bindir] [-n/--no-sign-cat] [-v/--no-sign-verify] -i input.zip
 echo .
 echo Warning! This script should normally be invoked from the repack directory
@@ -85,4 +89,9 @@
 :opt_n
 set _MY_OPT_SIGN_CAT=0
+shift
+goto argument_loop
+
+:opt_v
+set _MY_OPT_SIGN_VERIFY=0
 shift
 goto argument_loop
@@ -116,4 +125,5 @@
 :unzip_okay
 
+if ".%_MY_OPT_SIGN_VERIFY%" == ".0" goto no_sign_verify
 rem
 rem Verify it against the PreW10 catalog files we saved.
@@ -130,5 +140,5 @@
     "%_MY_SIGNTOOL%" verify /kp /c "%_MY_OPT_BINDIR%\%%d-PreW10.cat" "%_MY_OPT_BINDIR%\%%d.sys" || goto end_failed
 )
-
+:no_sign_verify
 
 rem