Index: trunk/doc/manual/user_ChangeLogImpl.xml
===================================================================
--- trunk/doc/manual/user_ChangeLogImpl.xml	(revision 82516)
+++ trunk/doc/manual/user_ChangeLogImpl.xml	(revision 82524)
@@ -36,5 +36,55 @@
 
   <sect1>
-    <title>Version 6.1.x (2019-xx-xx)</title>
+    <title>Version 6.1.0 (2019-xx-xx)</title>
+
+    <para>
+      This is a major update. The following major new features were
+      added:
+    </para>
+
+    <itemizedlist>
+
+      <listitem>
+        <para>
+          Implemented support for importing a virtual machine from Oracle
+          Cloud Infrastructure
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          Extended support for exporting a virtual machine to Oracle
+          Cloud Infrastructure, allowing the creation of multiple
+          virtual machines without re-uploading. Also added option to
+          export a VM to the cloud using the more efficient variant
+          "paravirtialized", and to specify free-form tags for cloud
+          images
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          Virtualization core: Support for nested hardware-virtualization
+          on Intel CPUs (starting with 5th generation Core i, codename
+          Broadwell), so far tested only with guest running VirtualBox
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          Graphics: New style 3D support (with VBoxSVGA and VMSVGA) remains,
+          old style 3D support (with VBoxVGA) has been completely removed
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          Shared Clipboard: Implemented experimental support for file transfers
+          (Windows hosts/guests only at the moment). Needs to be enabled via
+          VBoxManage (disabled by default).
+        </para>
+      </listitem>
+
+    </itemizedlist>
 
     <para>
@@ -46,30 +96,12 @@
       <listitem>
         <para>
-          Storage: Experimental support for virtio-scsi, for both hard disks and
-          optical drives (including boot support in BIOS)
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Storage: For optical drive emulation fix empty host drive case
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          ACPI: Report NVMe controller
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          VGA: Improve hardware and BIOS compatibility
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          VMSVGA 3D: Fixed OpenGL compressed textures
+          Virtualization core: Drop recompiler, i.e. running VMs now needs
+          a CPU supporting hardware virtualization
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          Runtime: Works now on hosts with many CPUs (limit now 1024)
         </para>
       </listitem>
@@ -85,58 +117,92 @@
       <listitem>
         <para>
-          Linux host: Improve vboxweb systemd service dependency information
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Linux host: Drop PCI passthrough, the current code is too incomplete
-          (cannot handle PCIe devices at all), i.e. not useful enough
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Windows host: When possible, distinguish devices by port number; helps
-          when multiple otherwise identical devices are connected
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          EFI: Added support for booting from APFS
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          EFI: Added support for non-standard SATA and NVMe boot device paths
-          created by OS X
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          EFI: Modified updated EFI code base to support older OS X guests again
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Windows guest: DXVA implementation for WDDM driver
-        </para>
-      </listitem>
-
-    </itemizedlist>
-  </sect1>
-
-  <sect1>
-    <title>Version 6.1.0_RC1 (2019-11-22)</title>
-
-    <para>
-        In addition, the following items were fixed and/or added:
-    </para>
-
-    <itemizedlist>
+            GUI: Improved the VISO creation and file manager dialogs
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          GUI: Virtual machine list of VirtualBox Manager was improved. Machine
+          groups are now more obvious visually and VM search functionality
+          has been improved. Global Tools element can now be pinned in place,
+          to avoid scrolling it with rest of machine list
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          GUI: Virtual machine details pane is now extended with embedded editors
+          for selected VM attributes, allowing user to edit them on-the-fly byi
+          clicking corresponding hyper-links without opening VM settings dialog
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          GUI: Details pane provides more complete information
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          GUI: Internal medium enumeration routines were optimized to reduce the load
+          and optimize the performance in cases when user have lots
+          of media registered. Also, we again allowed to add existing media (and create new)
+          via Virtual Media Manager
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          GUI: More consistent medium selection (both showing known images
+          and allowing to select using the file picker)
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          GUI: VM storage settings page was adjusted a bit in usability regard. User is now
+          allowed to change controller bus type and can move attachments between the controllers
+          by using drag and drop
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          GUI: Storage and Network settings pages bug-fixes and usability optimization
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          GUI: Added a new soft (virtual) keyboard enabling arbitrary keyboard input to guests,
+          including multimedia keys
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          GUI: Fixed crash in cloud related wizards when accessibility
+          functionality was enabled
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          GUI: Show VM CPU load as part of status bar CPU indicator
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          GUI: Improved and extended the Session Information dialog
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          GUI: Fixed/improved mouse pointer scaling
+        </para>
+      </listitem>
 
       <listitem>
@@ -149,24 +215,5 @@
       <listitem>
         <para>
-          GUI: Few usability related fixes for export appliance wizard
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          GUI: Fixed/improved mouse pointer scaling
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          GUI: Fixed crash in cloud related wizards when accessibility
-          functionality was enabled
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          GUI: Soft keyboard visual improvements, and fix crash for first use
+          GUI: Fix and unify geometry save/restore in various dialogs
         </para>
       </listitem>
@@ -181,20 +228,106 @@
       <listitem>
         <para>
-          GUI: More consistent medium selection (both showing known images
-          and allowing to select using the file picker)
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Documentation: Updated supported host operating systems, added few
-          new manual pages (more to come later)
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Virtualization core: Improvements for nested hardware-virtualization
-          on Intel CPUs
+          GUI: Popup messages mouse click fix
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          Graphics: Remove 3D support for VBoxVGA (old one deprecated with 6.0)
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          Graphics: Additional texture format support on Windows host
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          Graphics: Improved fix for flickering on Windows host
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>Input: Added support for horizontal scrolling in the PS/2 mouse
+          device using the IntelliMouse Explorer protocol. Note that this support
+          is automatically used by Linux guests but not by Windows guests
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>vboximg-mount: Experimental support for direct read-only access
+          to NTFS, FAT and ext2/3/4 filesystems inside a disk image without
+          the need for support on the host
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>vboximg-mount: Now also available on Linux host
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          Storage: Experimental support for virtio-scsi, for both hard disks and
+          optical drives (including boot support in BIOS)
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          Storage: For optical drive emulation fix empty host drive crash
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          USB: Improvements for EHCI controller implementation
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          USB: Filter can now specify port path, uniquely identifying a port
+          in a system
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          NAT: Fix TFTP OACK response, send only if request has options
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          NAT Network: Use non-blocking sockets on Linux for accepted
+          incoming connections (port forwarding)
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          PCnet-ISA: Added new network adapter type, currently CLI only
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          Audio: Allow changing the host audio backend while the VM is
+          in saved state
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          ACPI: Report NVMe controller
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          VGA: Improve hardware and BIOS compatibility
         </para>
       </listitem>
@@ -217,25 +350,43 @@
       <listitem>
         <para>
-          USB: Improvements for EHCI controller implementation
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          USB: Filter can now specify port path, uniquely identifying a port
-          in a system
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          NAT Network: Use non-blocking sockets on Linux for accepted
-          incoming connections (port forwarding)
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          PCnet-ISA: Added new network adapter type, currently CLI only
+          VMSVGA 3D: Fixed OpenGL compressed textures
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          VBoxManage: More cloud functionality coverage, e.g. starting
+          a cloud instance
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          VBoxManage: As part of the guest control feature support moving
+          multiple source files/directories to a target directory
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>Guest Control/VBoxManage: Added support for specifying multiple sources
+          when renaming guest files
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>VBoxManage: Show "unrestricted guest" and "nested HW
+        virtualization" CPU features when listing the host information</para>
+      </listitem>
+
+      <listitem>
+        <para>
+          API: Reduce the amount of leftovers from Move VM function
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          Shared Clipboard: Implemented experimental support for file transfers
+          for Linux hosts on Windows guests (disabled by default)
         </para>
       </listitem>
@@ -255,12 +406,19 @@
 
       <listitem>
-        <para>VBoxManage: Show "unrestricted guest" and "nested HW
-        virtualization" CPU features when listing the host information</para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Shared Clipboard: Implemented experimental support for file transfers
-          for Linux hosts on Windows guests (disabled by default)
+        <para>
+          macOS host: Fix VM crashes (most visible on macOS Catalina)
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          Linux host: Improve vboxweb systemd service dependency information
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          Linux host: Drop PCI passthrough, the current code is too incomplete
+          (cannot handle PCIe devices at all), i.e. not useful enough
         </para>
       </listitem>
@@ -277,4 +435,12 @@
       <listitem>
         <para>
+          Windows host: When possible, distinguish USB devices by port number; helps
+          with accurate capturing of devices when multiple otherwise identical devices
+          are connected
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
           Windows Guest Additions: Many fixes for drawing problems in the
           driver for VBoxSVGA
@@ -295,150 +461,14 @@
       </listitem>
 
-    </itemizedlist>
-  </sect1>
-
-  <sect1>
-    <title>Version 6.1.0_BETA2 (2019-10-23)</title>
-
-    <para>
-        In addition, the following items were fixed and/or added:
-    </para>
-
-    <itemizedlist>
-
-      <listitem>
-        <para>
-          Virtualization core: Improvements for nested hardware-virtualization
-          on Intel CPUs, Windows works now on outer VM (needs beta VirtualBox)
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Virtualization core: Drop recompiler, i.e. running VMs now needs
-          a CPU supporting hardware virtualization
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Runtime: Works now on hosts with many CPUs (limit now 1024)
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          GUI: Storage and Network settings pages bug-fixes and usability optimization
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          GUI: Show VM CPU load as part of status bar CPU indicator
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          GUI: Media enumeration fixes
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          GUI: Popup messages mouse click fix
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          GUI: Details pane fixes
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          GUI: Added multimedia keys to soft keyboard and other improvements
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          GUI: Fix and unify geometry save/restore in various dialogs
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Cloud: More flexibility in VM export and import to Oracle Cloud
-          Infrastructure, add free-form tags to cloud images
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Graphics: Remove 3D support for VBoxVGA (old one deprecated with 6.0)
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Graphics: Additional texture format supportd on Windows host
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Graphics: Improved fix for flickering on Windows host
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          NAT: Fix TFTP OACK response, send only if request has options
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          API: Reduce the amount of leftovers from Move VM function
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Audio: Allow changing the host audio backend while the VM is
-          in saved state
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>vboximg-mount: Now also available on Linux host
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          VBoxManage: More cloud functionality coverage, e.g. starting
-          a cloud instance
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          VBoxManage: As part of the guest control feature support moving
-          multiple source files/directories to a target directory
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          macOS host: Fix VM crashes (most visible on macOS Catalina)
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Windows host: Improve USB device capturing accuracy
+      <listitem>
+        <para>
+          Windows guest: DXVA implementation for WDDM driver
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          Documentation: Updated supported host operating systems, added few
+          new manual pages (more to come later)
         </para>
       </listitem>
@@ -451,142 +481,26 @@
       </listitem>
 
+      <listitem>
+        <para>
+          EFI: Added support for booting from APFS
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          EFI: Added support for non-standard SATA and NVMe boot device paths
+          created by OS X
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>
+          EFI: Modified updated EFI code base to support older OS X guests again
+        </para>
+      </listitem>
+
     </itemizedlist>
 
   </sect1>
 
-  <sect1>
-    <title>Version 6.1.0_BETA1 (2019-09-12)</title>
-
-    <para>
-      This is a major update. The following major new features were
-      added:
-    </para>
-
-    <itemizedlist>
-
-      <listitem>
-        <para>
-          Implemented support for importing a virtual machine from Oracle
-          Cloud Infrastructure
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Extended support for exporting a virtual machine to Oracle
-          Cloud Infrastructure, allowing the creation of multiple
-          virtual machines without re-uploading. Also added option to
-          export a VM to the cloud using the more efficient variant
-          "paravirtialized"
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Virtualization core: Support for nested hardware-virtualization
-          on Intel CPUs (starting with 5th generation Core i, codename
-          Broadwell)
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Graphics: New style 3D support (with VBoxSVGA and VMSVGA) remains,
-          old style 3D support (with VBoxVGA) has been completely removed
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          Shared Clipboard: Implemented experimental support for file transfers
-          (Windows hosts/guests only at the moment). Needs to be enabled via
-          VBoxManage (disabled by default).
-        </para>
-      </listitem>
-
-    </itemizedlist>
-
-    <para>
-        In addition, the following items were fixed and/or added:
-    </para>
-
-    <itemizedlist>
-
-      <listitem>
-        <para>
-            GUI: Improved the VISO creation and file manager dialogs
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          GUI: Virtual machine list of VirtualBox Manager was improved. Machine
-          groups are now more obvious visually and VM search functionality
-          has been improved. Global Tools element can now be pinned in place,
-          to avoid scrolling it with rest of machine list
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          GUI: Virtual machine details pane is now extended with embedded editors
-          for certain VM attributes which we decided as the most
-          important, allowing user to edit them on-the-fly by clicking corresponding
-          hyper-links without opening VM settings dialog
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          GUI: Internal medium enumeration routines were optimized to reduce the load
-          and optimize the performance in cases when user have lots
-          of media registered. Also, we again allowed to add existing media (and create new)
-          via Virtual Media Manager
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          GUI: VM storage settings page was adjusted a bit in usability regard. User is now
-          allowed to change controller bus type and can move attachments between the controllers
-          by using drag and drop
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          GUI: Added a new soft (virtual) keyboard enabling keyboard inputs to guests
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>
-          GUI: Improved and extended the Session Information dialog
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>Input: Added support for horizontal scrolling in the PS/2 mouse
-          device using the IntelliMouse Explorer protocol. Note that this support
-          is automatically used by Linux guests but not by Windows guests
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>vboximg-mount: Experimental support for direct read-only access
-          to NTFS, FAT and ext2/3/4 filesystems inside a disk image without
-          the need for support on the host
-        </para>
-      </listitem>
-
-      <listitem>
-        <para>Guest Control/VBoxManage: Added support for specifying multiple sources
-          when renaming guest files
-        </para>
-      </listitem>
-
-    </itemizedlist>
-
-  </sect1>
-
 </chapter>