Index: trunk/src/VBox/Devices/Audio/DrvHostALSAAudio.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DrvHostALSAAudio.cpp	(revision 82579)
+++ trunk/src/VBox/Devices/Audio/DrvHostALSAAudio.cpp	(revision 82580)
@@ -1164,5 +1164,5 @@
     AssertPtrReturn(pBackendCfg, VERR_INVALID_POINTER);
 
-    RTStrPrintf2(pBackendCfg->szName, sizeof(pBackendCfg->szName), "ALSA audio driver");
+    RTStrPrintf2(pBackendCfg->szName, sizeof(pBackendCfg->szName), "ALSA");
 
     pBackendCfg->cbStreamIn  = sizeof(ALSAAUDIOSTREAM);
Index: trunk/src/VBox/Devices/Audio/DrvHostCoreAudio.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DrvHostCoreAudio.cpp	(revision 82579)
+++ trunk/src/VBox/Devices/Audio/DrvHostCoreAudio.cpp	(revision 82580)
@@ -2184,5 +2184,5 @@
     RT_BZERO(pBackendCfg, sizeof(PDMAUDIOBACKENDCFG));
 
-    RTStrPrintf2(pBackendCfg->szName, sizeof(pBackendCfg->szName), "Core Audio driver");
+    RTStrPrintf2(pBackendCfg->szName, sizeof(pBackendCfg->szName), "Core Audio");
 
     pBackendCfg->cbStreamIn  = sizeof(COREAUDIOSTREAM);
Index: trunk/src/VBox/Devices/Audio/DrvHostDSound.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DrvHostDSound.cpp	(revision 82579)
+++ trunk/src/VBox/Devices/Audio/DrvHostDSound.cpp	(revision 82580)
@@ -2183,5 +2183,5 @@
     pBackendCfg->cbStreamIn  = sizeof(DSOUNDSTREAM);
 
-    RTStrPrintf2(pBackendCfg->szName, sizeof(pBackendCfg->szName), "DirectSound audio driver");
+    RTStrPrintf2(pBackendCfg->szName, sizeof(pBackendCfg->szName), "DirectSound");
 
     pBackendCfg->cMaxStreamsIn  = UINT32_MAX;
Index: trunk/src/VBox/Devices/Audio/DrvHostDebugAudio.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DrvHostDebugAudio.cpp	(revision 82579)
+++ trunk/src/VBox/Devices/Audio/DrvHostDebugAudio.cpp	(revision 82580)
@@ -71,5 +71,5 @@
     AssertPtrReturn(pBackendCfg, VERR_INVALID_POINTER);
 
-    RTStrPrintf2(pBackendCfg->szName, sizeof(pBackendCfg->szName), "Debug audio driver");
+    RTStrPrintf2(pBackendCfg->szName, sizeof(pBackendCfg->szName), "DebugAudio");
 
     pBackendCfg->cbStreamOut    = sizeof(DEBUGAUDIOSTREAM);
Index: trunk/src/VBox/Devices/Audio/DrvHostNullAudio.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DrvHostNullAudio.cpp	(revision 82579)
+++ trunk/src/VBox/Devices/Audio/DrvHostNullAudio.cpp	(revision 82580)
@@ -89,5 +89,5 @@
     AssertPtrReturn(pBackendCfg, VERR_INVALID_POINTER);
 
-    RTStrPrintf2(pBackendCfg->szName, sizeof(pBackendCfg->szName), "NULL audio driver");
+    RTStrPrintf2(pBackendCfg->szName, sizeof(pBackendCfg->szName), "NULL audio");
 
     pBackendCfg->cbStreamOut    = sizeof(NULLAUDIOSTREAM);
Index: trunk/src/VBox/Devices/Audio/DrvHostOSSAudio.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DrvHostOSSAudio.cpp	(revision 82579)
+++ trunk/src/VBox/Devices/Audio/DrvHostOSSAudio.cpp	(revision 82580)
@@ -557,5 +557,5 @@
     RT_NOREF(pInterface);
 
-    RTStrPrintf2(pBackendCfg->szName, sizeof(pBackendCfg->szName), "OSS audio driver");
+    RTStrPrintf2(pBackendCfg->szName, sizeof(pBackendCfg->szName), "OSS");
 
     pBackendCfg->cbStreamIn  = sizeof(OSSAUDIOSTREAM);
Index: trunk/src/VBox/Devices/Audio/DrvHostPulseAudio.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DrvHostPulseAudio.cpp	(revision 82579)
+++ trunk/src/VBox/Devices/Audio/DrvHostPulseAudio.cpp	(revision 82580)
@@ -1128,5 +1128,5 @@
     RT_ZERO(Cfg);
 
-    RTStrPrintf2(Cfg.szName, sizeof(Cfg.szName), "PulseAudio driver");
+    RTStrPrintf2(Cfg.szName, sizeof(Cfg.szName), "PulseAudio");
 
     Cfg.cbStreamOut    = sizeof(PULSEAUDIOSTREAM);
Index: trunk/src/VBox/Devices/Audio/DrvHostValidationKit.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DrvHostValidationKit.cpp	(revision 82579)
+++ trunk/src/VBox/Devices/Audio/DrvHostValidationKit.cpp	(revision 82580)
@@ -83,5 +83,5 @@
     AssertPtrReturn(pBackendCfg, VERR_INVALID_POINTER);
 
-    RTStrPrintf2(pBackendCfg->szName, sizeof(pBackendCfg->szName), "Validation Kit audio driver");
+    RTStrPrintf2(pBackendCfg->szName, sizeof(pBackendCfg->szName), "Validation Kit");
 
     pBackendCfg->cbStreamOut    = sizeof(VAKITAUDIOSTREAM);