Index: trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsCommon.nsh
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsCommon.nsh	(revision 82584)
+++ trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsCommon.nsh	(revision 82587)
@@ -833,160 +833,7 @@
 !define PrepareWRPFileEx "!insertmacro PrepareWRPFileEx"
 
-;
-; Validates backed up and replaced Direct3D files; either the d3d*.dll have
-; to be from Microsoft or the (already) backed up msd3d*.dll files. If both
-; don't match we have a corrupted / invalid installation.
-; @return  Stack: "0" if files are valid; otherwise "1".
-;
-!macro ValidateFilesDirect3D un
-Function ${un}ValidateD3DFiles
-
-  Push $0
-
-  ; We need to switch to 64-bit app mode to handle the "real" 64-bit files in
-  ; "system32" on a 64-bit guest
-  Call ${un}SetAppMode64
-
-  ; Note: Not finding a file (like *d3d8.dll) on Windows Vista/7 is fine;
-  ;       it simply is not present there.
-
-  ; Note 2: On 64-bit systems there are no 64-bit *d3d8 DLLs, only 32-bit ones
-  ;         in SysWOW64 (or in system32 on 32-bit systems).
-
-!if $%BUILD_TARGET_ARCH% == "x86"
-  ${VerifyFileEx} "${un}" "$SYSDIR\d3d8.dll" "Microsoft Corporation" "$%BUILD_TARGET_ARCH%"
-  Pop $0
-  ${If} $0 == "1"
-    Goto verify_msd3d
-  ${EndIf}
-!endif
-
-  ${VerifyFileEx} "${un}" "$SYSDIR\d3d9.dll" "Microsoft Corporation" "$%BUILD_TARGET_ARCH%"
-  Pop $0
-  ${If} $0 == "1"
-    Goto verify_msd3d
-  ${EndIf}
-
-  ${If} $g_bCapDllCache == "true"
-!if $%BUILD_TARGET_ARCH% == "x86"
-    ${VerifyFileEx} "${un}" "$SYSDIR\dllcache\d3d8.dll" "Microsoft Corporation" "$%BUILD_TARGET_ARCH%"
-    Pop $0
-    ${If} $0 == "1"
-      Goto verify_msd3d
-    ${EndIf}
-!endif
-    ${VerifyFileEx} "${un}" "$SYSDIR\dllcache\d3d9.dll" "Microsoft Corporation" "$%BUILD_TARGET_ARCH%"
-    Pop $0
-    ${If} $0 == "1"
-      Goto verify_msd3d
-    ${EndIf}
-  ${EndIf}
-
-!if $%BUILD_TARGET_ARCH% == "amd64"
-  ${VerifyFileEx} "${un}" "$g_strSysWow64\d3d8.dll" "Microsoft Corporation" "x86"
-  Pop $0
-  ${If} $0 == "1"
-    Goto verify_msd3d
-  ${EndIf}
-  ${VerifyFileEx} "${un}" "$g_strSysWow64\d3d9.dll" "Microsoft Corporation" "x86"
-  Pop $0
-  ${If} $0 == "1"
-    Goto verify_msd3d
-  ${EndIf}
-
-  ${If} $g_bCapDllCache == "true"
-    ${VerifyFileEx} "${un}" "$g_strSysWow64\dllcache\d3d8.dll" "Microsoft Corporation" "x86"
-    Pop $0
-    ${If} $0 == "1"
-      Goto verify_msd3d
-    ${EndIf}
-    ${VerifyFileEx} "${un}" "$g_strSysWow64\dllcache\d3d9.dll" "Microsoft Corporation" "x86"
-    Pop $0
-    ${If} $0 == "1"
-      Goto verify_msd3d
-    ${EndIf}
-  ${EndIf}
-
-!endif
-
-  Goto valid
-
-verify_msd3d:
-
-!if $%BUILD_TARGET_ARCH% == "x86"
-  ${VerifyFileEx} "${un}" "$SYSDIR\msd3d8.dll" "Microsoft Corporation" "$%BUILD_TARGET_ARCH%"
-  Pop $0
-  ${If} $0 == "1"
-    Goto invalid
-  ${EndIf}
-!endif
-  ${VerifyFileEx} "${un}" "$SYSDIR\msd3d9.dll" "Microsoft Corporation" "$%BUILD_TARGET_ARCH%"
-  Pop $0
-  ${If} $0 == "1"
-    Goto invalid
-  ${EndIf}
-
-  ${If} $g_bCapDllCache == "true"
-!if $%BUILD_TARGET_ARCH% == "x86"
-    ${VerifyFileEx} "${un}" "$SYSDIR\dllcache\msd3d8.dll" "Microsoft Corporation" "$%BUILD_TARGET_ARCH%"
-    Pop $0
-    ${If} $0 == "1"
-      Goto invalid
-    ${EndIf}
-!endif
-    ${VerifyFileEx} "${un}" "$SYSDIR\dllcache\msd3d9.dll" "Microsoft Corporation" "$%BUILD_TARGET_ARCH%"
-    Pop $0
-    ${If} $0 == "1"
-      Goto invalid
-    ${EndIf}
-  ${EndIf}
-
-!if $%BUILD_TARGET_ARCH% == "amd64"
-  ${VerifyFileEx} "${un}" "$g_strSysWow64\msd3d8.dll" "Microsoft Corporation" "x86"
-  Pop $0
-  ${If} $0 == "1"
-    Goto invalid
-  ${EndIf}
-  ${VerifyFileEx} "${un}" "$g_strSysWow64\msd3d9.dll" "Microsoft Corporation" "x86"
-  Pop $0
-  ${If} $0 == "1"
-    Goto invalid
-  ${EndIf}
-
-  ${If} $g_bCapDllCache == "true"
-    ${VerifyFileEx} "${un}" "$g_strSysWow64\dllcache\msd3d8.dll" "Microsoft Corporation" "x86"
-    Pop $0
-    ${If} $0 == "1"
-      Goto invalid
-    ${EndIf}
-    ${VerifyFileEx} "${un}" "$g_strSysWow64\dllcache\msd3d9.dll" "Microsoft Corporation" "x86"
-    Pop $0
-    ${If} $0 == "1"
-      Goto invalid
-    ${EndIf}
-  ${EndIf}
-!endif
-
-  Goto valid
-
-valid:
-
-  StrCpy $0 "0" ; Installation valid
-  Goto end
-
-invalid:
-
-  StrCpy $0 "1" ; Installation invalid / corrupted
-  Goto end
-
-end:
-
-  Exch $0
-
-FunctionEnd
-!macroend
-!insertmacro ValidateFilesDirect3D ""
-!insertmacro ValidateFilesDirect3D "un."
-
+; Note: We don't ship modified Direct3D files anymore, but we need to (try to)
+;       restore the original (backed up) DLLs when upgrading from an old(er)
+;       installation.
 ;
 ; Restores formerly backed up Direct3D original files, which were replaced by
@@ -1041,13 +888,5 @@
 !endif
 
-  ; Do a re-validation afterwards.
-  Call ${un}ValidateD3DFiles
-  Pop $0
-  ${If} $0 == "1" ; D3D files are invalid
-    ${LogVerbose} $(VBOX_UNINST_UNABLE_TO_RESTORE_D3D)
-    MessageBox MB_ICONSTOP|MB_OK $(VBOX_UNINST_UNABLE_TO_RESTORE_D3D) /SD IDOK
-  ${EndIf}
-
-  Exch $0
+  Pop $0
 
 FunctionEnd
Index: trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsVista.nsh
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsVista.nsh	(revision 82584)
+++ trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsVista.nsh	(revision 82587)
@@ -22,42 +22,5 @@
   ${LogVerbose} "Checking for installation requirements for Vista / Windows 7 / Windows 8 ..."
 
-  ${If} $g_bForceInstall == "true"
-    ${LogVerbose} "Forcing installation, checking requirements skipped"
-    goto success
-  ${EndIf}
-
-  ; Validate D3D files, regardless whether D3D support is selected or not
-  Call ValidateD3DFiles
-  Pop $0
-  ${If} $0 == "1" ; D3D files are invalid, notify user
-    MessageBox MB_ICONSTOP|MB_OKCANCEL $(VBOX_COMPONENT_D3D_INVALID) /SD IDOK IDCANCEL failure
-    ; Offer to open up the VBox online manual on how to fix missing/corrupted D3D files
-    MessageBox MB_ICONQUESTION|MB_YESNO $(VBOX_COMPONENT_D3D_INVALID_MANUAL) /SD IDNO IDYES open_handbook_d3d_invalid
-  ${EndIf}
-  Goto success
-
-open_handbook_d3d_invalid:
-
-  ; @todo Add a language GET parameter (e.g. ?lang=enUS) here as soon as we got the
-  ;       handbook online in different languages
-  ; Don't use https here (even if we offer it) -- we only want to display the handbook
-  Call SetAppMode64 ; For shell execution we need to switch to 64-bit mode first
-  ExecShell open "http://www.virtualbox.org/manual/ch12.html#ts_d3d8-d3d9-restore"
-  IfErrors 0 +2
-    MessageBox MB_ICONSTOP|MB_OK $(VBOX_ERROR_OPEN_LINK) /SD IDOK
-  Call SetAppMode32
-  Goto failure
-
-failure:
-
-  Abort "ERROR: Requirements not met! Installation aborted."
-  goto exit
-
-success:
-
-  ; Nothing to do here right now
-  Goto exit
-
-exit:
+  ; Nothing to do here right now.
 
   Pop $0