Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts	(revision 82696)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts	(revision 82697)
@@ -2909,13 +2909,13 @@
     <message>
         <source>Include all network adapter MAC addresses during importing.</source>
-        <translation type="unfinished"></translation>
+        <translation>Включать MAC-адреса всех сетевых адаптеров во время импорта.</translation>
     </message>
     <message>
         <source>Include only NAT network adapter MAC addresses during importing.</source>
-        <translation type="unfinished"></translation>
+        <translation>Включать только MAC-адреса сетевого адаптера NAT во время импорта.</translation>
     </message>
     <message>
         <source>Generate new MAC addresses for all network adapters during importing.</source>
-        <translation type="unfinished"></translation>
+        <translation>Сгенерировать новые MAC-адреса всех сетевых адаптеров во время импорта.</translation>
     </message>
 </context>
@@ -4983,10 +4983,10 @@
         <source>Paravirtualized Network (virtio-net 1.0)</source>
         <comment>NetworkAdapterType</comment>
-        <translation type="unfinished"></translation>
+        <translation>Паравиртуальная сеть (virtio-net 1.0)</translation>
     </message>
     <message>
         <source>PCnet-ISA (Am79C960)</source>
         <comment>NetworkAdapterType</comment>
-        <translation type="unfinished"></translation>
+        <translation></translation>
     </message>
 </context>
@@ -5027,9 +5027,9 @@
     <message>
         <source>New Directory</source>
-        <translation type="unfinished">Новая папка</translation>
+        <translation>Новая папка</translation>
     </message>
     <message>
         <source>Local Path</source>
-        <translation type="unfinished">Локальный путь</translation>
+        <translation>Локальный путь</translation>
     </message>
 </context>
@@ -6879,5 +6879,5 @@
     <message>
         <source>No Guest Session found!&lt;br&gt;Please use the Session Panel to start a new guest session</source>
-        <translation type="unfinished"></translation>
+        <translation>Гостевая сессия не обнаружена!&lt;br&gt;Пожалуйста используйте панель сессий для запуска новой</translation>
     </message>
 </context>
@@ -7162,5 +7162,5 @@
     <message>
         <source>Assign value ...</source>
-        <translation type="unfinished"></translation>
+        <translation>Задаём значение ...</translation>
     </message>
 </context>
@@ -9608,9 +9608,9 @@
     <message>
         <source>Adding network ...</source>
-        <translation type="unfinished"></translation>
+        <translation>Создание сети ...</translation>
     </message>
     <message>
         <source>Removing network ...</source>
-        <translation type="unfinished"></translation>
+        <translation>Удаление сети ...</translation>
     </message>
 </context>
@@ -13377,5 +13377,5 @@
     <message>
         <source>Choose/Create a disk image...</source>
-        <translation type="unfinished">Выбрать/создать образ диска...</translation>
+        <translation>Выбрать/создать образ диска...</translation>
     </message>
 </context>
@@ -14275,9 +14275,9 @@
     <message>
         <source>Moving medium ...</source>
-        <translation type="unfinished"></translation>
+        <translation>Перенос носителя ...</translation>
     </message>
     <message>
         <source>Removing medium ...</source>
-        <translation type="unfinished"></translation>
+        <translation>Удаление носителя ...</translation>
     </message>
 </context>
@@ -14547,9 +14547,9 @@
     <message>
         <source>Moving medium ...</source>
-        <translation type="unfinished"></translation>
+        <translation>Перенос носителя ...</translation>
     </message>
     <message>
         <source>Resizing medium ...</source>
-        <translation type="unfinished"></translation>
+        <translation>Изменение размера носителя ...</translation>
     </message>
 </context>
@@ -18812,5 +18812,5 @@
     <message>
         <source>The file will be saved under:&lt;br&gt;</source>
-        <translation type="unfinished"></translation>
+        <translation>Файл будет сохранён в:&lt;br&gt;</translation>
     </message>
 </context>
@@ -19555,50 +19555,50 @@
     <message>
         <source>&amp;Guest Control</source>
-        <translation type="unfinished"></translation>
+        <translation>&amp;Контроль гостевой ОС</translation>
     </message>
     <message>
         <source>turned off</source>
         <comment>Screen</comment>
-        <translation type="unfinished">выключена</translation>
+        <translation>выключен</translation>
     </message>
     <message>
         <source>Active</source>
         <comment>Nested Paging</comment>
-        <translation type="unfinished"></translation>
+        <translation>Активна</translation>
     </message>
     <message>
         <source>Inactive</source>
         <comment>Nested Paging</comment>
-        <translation type="unfinished"></translation>
+        <translation>Неактивна</translation>
     </message>
     <message>
         <source>Active</source>
         <comment>Unrestricted Execution</comment>
-        <translation type="unfinished"></translation>
+        <translation>Активна</translation>
     </message>
     <message>
         <source>Inactive</source>
         <comment>Unrestricted Execution</comment>
-        <translation type="unfinished"></translation>
+        <translation>Неактивна</translation>
     </message>
     <message>
         <source>Not Available</source>
         <comment>VRDE Port</comment>
-        <translation type="unfinished">Не доступен</translation>
+        <translation>Не доступен</translation>
     </message>
     <message>
         <source>not set</source>
         <comment>Execution Engine</comment>
-        <translation type="unfinished">Не задан</translation>
+        <translation>не задан</translation>
     </message>
     <message>
         <source>Not Detected</source>
         <comment>Guest OS Type</comment>
-        <translation type="unfinished"></translation>
+        <translation>Не определен</translation>
     </message>
     <message>
         <source>Not Detected</source>
         <comment>Guest Additions Version</comment>
-        <translation type="unfinished"></translation>
+        <translation>Не определены</translation>
     </message>
 </context>
@@ -20871,5 +20871,5 @@
     <message>
         <source>Acquire export form ...</source>
-        <translation type="unfinished"></translation>
+        <translation>Получение формы экспорта ...</translation>
     </message>
 </context>
@@ -21084,21 +21084,21 @@
     <message>
         <source>Acquire cloud instances ...</source>
-        <translation type="unfinished"></translation>
+        <translation>Получение облачных экземпляров машин ...</translation>
     </message>
     <message>
         <source>Read appliance ...</source>
-        <translation type="unfinished"></translation>
+        <translation>Чтение конфигурации ...</translation>
     </message>
     <message>
         <source>Acquire import form ...</source>
-        <translation type="unfinished"></translation>
+        <translation>Получение формы импорта ...</translation>
     </message>
     <message>
         <source>Please choose the source to import appliance from.  This can be a local file system to import OVF archive or one of known cloud service providers to import cloud VM from.</source>
-        <translation type="unfinished"></translation>
+        <translation>Пожалуйста, выберите источник для импорта конфигурации.  Это может быть как локальная файловая система для импорта OVF архива, так и один из известных провайдеров облачных сервисов для импорта машины напрямую из облака.</translation>
     </message>
     <message>
         <source>&amp;Source:</source>
-        <translation type="unfinished">&amp;Источник:</translation>
+        <translation>&amp;Источник:</translation>
     </message>
 </context>
@@ -21174,13 +21174,13 @@
     <message>
         <source>Acquire launch form ...</source>
-        <translation type="unfinished"></translation>
+        <translation>Получение формы запуска ...</translation>
     </message>
     <message>
         <source>Acquire cloud images ...</source>
-        <translation type="unfinished"></translation>
+        <translation>Получение облачных образов дисков ...</translation>
     </message>
     <message>
         <source>&amp;Destination:</source>
-        <translation type="unfinished">&amp;Расположение:</translation>
+        <translation>&amp;Расположение:</translation>
     </message>
 </context>